Index aide

Jeu Shisen-sho pour Windows

Jouer à Shisen-Sho

Historique de ce jeu et données techniques

Jouer à Shisen-sho

Sauver un jeu

Commande souris et clavier

Autres options

Gérer les jeux de tuiles (pions)

Le signe de l›hippocampe

Problèmes connus

Licence

Langue

Version 1.30

Tous droits Daniel F Valot 28 Octobre 2006

Email:

http://dvalot.free.fr


Histoire du jeu

Histoire du jeu et données techniques

D'où vient le jeu:

Je ne sais pas d'où vient le jeu.

Que veut dire Shisen-sho:

On m'a dit que le nom « Shisen-Sho » est le nom anglais d'une province Chinoise.

Comment le jeu a été développé:

J'ai vu ce jeu pour la premère fois sous KDE (Linus).(Créé en 1997 par Mario Weilguni mweilguni@sime.com qui a utilisé la technologie « QT »)

Il y a plusieurs versions pour Windows sur Internet.

J'ai d'abord essayé d'imiter la version KDE tout en écrivant un code original. Ce n'est pas un portage de la version KDE. Ce programme a complètement été écrit en utilisant uniquement des API Windows et en créant une nouvelle technique de résolution.

Certaines réalisations m'ont donné des idées:

Shisen pour Win32 par Ono Shinji (1998)

Shisen Sho pour Java par Barry Neilsen (1999) barry@redsand.demon.co.uk

Quelques jeux de tuiles ont été réalisés avec une partie des exemples de « IBM Visualage Toolkit » Mahjong .

D'autres jeux de tuiles utilisent des tuiles du domaine publique maintenues par Ron Balewski pour son Mahjong (MJVGA et MJWIN)(Ron Balewski 412 E. Ridge St. Nanticoke, PA 18634-2915) ; pour ces jeux de tuiles , j'ai créé une tuile en 3D sur laquelle j'ai copier le dessin original.

L'idée d'origine qui m'a poussé à écrire ce programme était de me passer de Linux.

Développement:

Microsoft Visual C# 2005 Express Edition est utilisé pour compiler ce programme.
.Net version 3 Framework est nécessaire pour exécuter ce programme.

Propriétés et scores:

Ces données sont stockées dans les propriétés de l'application sous:

C:\Documents and Settings\User_Name\Local Settings\Application Data\TheSeaHorse\ShisenCS.exe_Url_idkttb4ign45k02ia1a22wznel4lec1a\4.3.4.0...

Tout ce qui est après "TheSeaHorse" varie pour chaque installation.

Figure 2 Données du registre pour Shisen-sho

Version OS/2 :

Il y a une version pour OS/2 disponible sur ma “home page”.

Possibilités:

Cette version de Shisen-sho a plus de possibilités que toutes les versions ci-dessus. Sa taille peut être ajustée.


Utilisation du clavier

Touches du clavier

Raccourcis clavier de Shisen-sho :

Les touches disponibles sont:

  • Ctrl-A Voir toutes les solutions (Mode triche)

  • Ctrl-F Mode chute. (Active ou désactive ce mode)

  • Ctrl-G Mode Gravité. (Active ou désactive ce mode)

  • Ctrl-H Voir une solution au hasard

  • Ctrl-I Le plateau est-il soluble ?

  • Ctrl-N Nouveau jeu

  • Ctrl-P Pauser/Continuer le jeu

  • Ctrl-R Refaire le dernier défait

  • Ctrl-S Redémarrer au début (même chose que « défaire » à répétition Ctrl-X)

  • Ctrl-C Comme Ctrl-S avec effacement des historiques et du compteur de temps.

  • Ctrl-T Mode Attraction. (Active ou désactive ce mode)

  • Ctrl-X Défaire

  • Alt-F4 Quitter le jeu

  • Alt-F11 Meilleurs scores

  • Alt-F12 Au sujet de

  • Alt-Entrée Bascule du mode fenêtre au mode plein écran et de plein écran à fenêtre.

  • F1 Obtenir de l' Aide (Cela peut être fait après la sélection de n'importe quelle entrée de menu.)

  • F3 Quitter le jeu

  • F10 sélection du menu

  • F11 Bascule du mode fenêtre au mode plein écran et de plein écran à fenêtre.

  • La barre d'espace arrête la démonstration.

  • Touche pause Pauser/Continuer le jeu

  • ESC arrète le plein écran ou/et la pause.

Emulation de la souris au clavier

Les personnes à mobilité réduite peuvent jouer à Shisen-sho avec un seul doigt ou équivalent

Les touches disponibles sont:

Clavier numérique en mode non numérique (8 directions)

  • Caractères du clavier 'e', 'r','t','d','g','c','v','b'' pour les 8 directions

  • Sélection des tuiles avec le 5 du clavier numérique en mode non numérique ou avec le caractère "f"', touche entrée, barre espace.

  • Aide pour une solution avec touche majuscule

  • Les touches Insert et "n" remplacent le bouton droit de la souris pour montrer toutes les tuiles du même type

  • Toutes les solutions avec Ctrl-a

  • Accès standard aux menus avec les touches de Windows 'Alt' et touches de directions.

  • Sélection des entrées de menu avec la touche entrée.

Emploi de la souris avec Shisen-sho:

Bouton de gauche: sélection d'une nouvelle tuile (première ou seconde de la paire). Annule une sélection.

Bouton de droite: montre toutes les tuiles de même type.

Barre d'outils:

C'est un accès direct à certaines fonctions des menus.


Langue

Passer d'une langue à une autre:

Shisen-Sho a le support des langues nationales inclus.

Quand une langue existe, une DLL est disponible dans le répertoire de Shisen-Sho.

S'il y a de multiples langues, le menu de langue montre ces langues disponibles.

Vous pouvez passer d'une langue à une autre en jouant.

Shisen-Sho mémorise la dernière langue utilisée et démarre dans cette langue.

A ce jour les traductions suivantes existent:

  • German par Christian Hennecke

  • French par Daniel F Valot

  • Hungarian par Leonard Nimoy

  • Italian par Marco D›Amato

  • Norwegian parVegard Krog Petersen

  • Russian par Iren Matsenko

  • Swedish par Jan-Erik Lärka

  • Uzbek par Sherzod Mamatkulov


Informations sur la Licence

Licence

<<Daniel F Valot Software>> La famille de programmes ARDI.

Licence et informations Légales :

  • Shisen-sho est appelé le programme Shisen dans la suite.

  • Ce programme SHISEN appartient à Daniel F Valot

  • Vous avez droit à une licence non exclusive de ce programme SHISEN pour votre propre usage seulement. L'utilisateur ne doit pas distribuer commercialement, sous licencier ou revendre ou transférer pour aucune considération, ou reproduire pour de tel raisons le programme SHISEN ou aucune variante ou modification de celui-ci ou joint à d'autres produits ou programmes. De plus l'utilisateur ne doit pas modifier ce programme SHISEN pour autre chose que ses propres affaires.

LE PROGRAMME SHISEN EST FOURNI A L'UTILISATEUR « TEL QUEL » L'AUTEUR NE FAIT AUCUNE GARANTIE, NI EXPRIMEE NI IMPLICITE QUANT AU PROGRAMME SHISEN ET/OU LES AUTRES ELEMENTS FOURNIS A L'UTILISATEUR, Y COMPRIS, MAIS NON LIMITE A LA QUALITE MARCHANDE OU L'APTITUDE A UNE UTILISATION DONNEE, ET CONTRE LES VICES DE FABRICATION.

==LIMITE de Responsabilité-- --L'AUTEUR NE PEUT ETRE TENU POUR RESPONSABLE D'AUCUNE RECLAMATION OU DOMMAGE,QU'IL SOIT INCLUANT LES ATTEINTES A LA PROPRIETE INTELLECTUELLE, PERTES DE PROFITS OU INTERRUPTION DES AFFAIRES, OU POUR AUCUN DOMMAGE SPECIAL CONSECUTIF OU FORTUIT QUELLE QU'EN SOIT LA CAUSE, QUE CELA SE PRODUISE PAR UN DEFAUT DE GARANTIE, DE CONTRAT, TORT (INCLUANT LA NEGLIGENCE), STRICTE RESPONSABILITE, OU AUTREMENT.

==Shisen.exe n'est pas un programme "freeware" ou "Shareware"

Vous pouvez seulement l›obtenir depuis http://dvalot.free.fr .

Vous n›avez rien à payer pour les versions 1.00 à 1.30


Ajout de jeux de tuiles

Gérer les jeux de tuiles externes

Ou sont stockés les jeux de tuiles ?

Un ou deux jeux sont résidents dans le programme

Les autre sont stockés dans un fichier de type DLL dans le répertoire de l'application.

La version du fan club de Irina Allegrova n'a qu'un jeu résident et aucune DLL.

A partir de la version 1.14 Vous pouvez créer vos propres jeux de tuiles.

Vous pouvez vous inspirer des quelques jeux de tuiles externes fournis avec SHISEN-SHO.

Comment créer des jeux de tuiles externes ?

Ce sont des bitmaps de 8 bit (256 couleurs) .

Les tuiles sont placées en six rangées de neuf tuiles.

Il y a un pixel ajouté à gauche et en bas de chaque tuile.

Utilisez les exemples fournis avec SHISEN-SHO comme point de départ. La taille ne doit pas être trop grande pour être utilisable sans trop consommer de mémoire. La bitmap WALTE256.BMP est trop grande pour être utilisable sur toutes les machines. Je recommende d'utiliser TEMPLATE.BMP pour point de départ.

Comment ajouter mes jeux de tuiles au jeu ?

Placer le fichier dans le répertoire de l'application SHISEN-SHO.

Aller au menu « fichiers » et sélectez « Organise tuiles externes »

Dans le dialogue pressez « Ajouter » pour choisir votre fichier bitmap.

Replacer le nom du jeu de tuile et votre nom dans le champ auteur ou origine.

Ajustez la couleur du coté des tuiles avec les rouge vert bleu.(plusieurs tentatives peuvent être nécessaires)

Vous aurez la possibilité de faire des changements par la suite si les tests ne sont pas satisfaisants.

Appuyez sur Sauver pour enregistrer les données dans la liste des jeux de tuiles externes (SHISENTS.LST)

Comment supprimer des entrées dans la liste des jeux de tuiles externes ?

Allez au menu « organise tuiles externes »

Utilisez les boutons « suivant » « précèdent » pour choisir le fichier désiré et appuyez sur « supprimer » pour l'enlever de la liste.

Cela n'effacera pas le fichier du répertoire.

Comment changer la couleur de coté des tuiles externes ?

Allez au menu « organise tuiles externes »

Utilisez les boutons « suivant » « précèdent » pour choisir le fichier désiré et chager la couleur avec rouge vert et bleu, puis appuyez sur « sauver ».


Autres options

Les autres options disponibles sont:

Quelques possibilités sont juste là pour s'amuser:

  1. La vitesse est pour l'animation d'affichage. Chaque paire sélectée démarre un nouveau processus.

  2. Liens animés.

  3. Affichage des meilleurs score. Vous pouvez supprimer les lignes du tableau.

Il y a un tableau de résultat pour chaque taille de tableau. Le tableau des résultat montre le mode utilisé pour résoudre le plateau (Normal, Gravité; Chute ou attraction) ; La barre de titre montre la taille du plateau.


Jouer à Shisen-sho

Disposition du plateau :

Le plateau est construit différemment suivant:

1-La taille et les jeux de tuiles

La taille peut être choisie parmi 14*6, 18*8, 24*12, 26*14 ou 30*16. (Avec Paramètres->taille)

De un à dix-huit jeux de tuiles sont fournis actuellement.

2-Le niveau de difficulté

Il peut être choisi comme « facile », « moyen » or « difficile ». Il n'y a pas grande différence entre « moyen » et « difficile ». « Difficile » supprime un certain nombre de tuiles adjacentes de même valeur (Avec Paramètres->Niveau.)

3-Jeux solubles:

Quand il construit le plateau de jeu, le programme essaye de résoudre le plateau avec une de ses procédures internes. Ces procédures ne sont pas aussi performantes que je le souhaiterai. Quand le programme vous dit que le jeu est soluble, vous pouvez le croire, mais s'il vous dit qu'il n'est pas soluble, cela veut simplement dire qu'il n'a pas trouvé de solution. Les seules procédures qui étaient fiables pour résoudre le jeu, prenaient des heures… pour cette raison, je ne les ai pas utilisées.

4-Mode gravité:

Dans ce mode les tuiles glissent vers vous (le bas de l'écran). « Défaire » et « refaire » peuvent aussi être utilisés. Ce mode doit être activé avant de commencer la partie.

5-Mode chute:

Cela combine le mode Gravité et des chutes de tuiles (une pas coup au maximum). La hauteur des colonnes de tuiles sont comparées entre elles et la tuile la plus haute par rapport à sa voisine lui tombe dessus. S'il y a des écarts équivalents, la tuile la plus à gauche tombe.

6-Mode attraction:

Dans ce mode, les rangées vides verticalement, ou horizontalement, sont supprimées.

Cela rend le jeu plus difficile.

7-Supprimer le bip:

Pour être plus silencieux.

8-Supprimer l'affichage 3D :

Pour gagner de la vitesse (on slow PC)

9-Photo du mont Asama en fond :

A utiliser si vous n'avez pas charger votre propre image de fond (« Fichiers->Charge bitmap de fond »). Le mont Asama est situé près de Tokyo.

10-Emulation de la souris pour personnes à mobilité réduite:

Cela permet d'utiliser le jeu avec un doigt ou équivalent. (Sans souris) Lire Commandes souris et clavier

11-Utiliser l'image de fond par défaut:

Pour éviter d'utiliser votre propre image de fond. Vous avez pu charger votre propre image de fond avec « Fichiers->Charge bitmap de fond ». Seul les images bitmap Windows (RLE) et OS/2 sont supportées. Charger une images non supportée peut donner des résultats imprévisibles..

Action “défaire” et “refaire”

Toutes les tuiles enlevées sont ajoutées à l'historique « défaire » de la partie.

Les tuiles que vous replacez avec l'option « refaire » sont ajoutées à l'historique « refaire ».

Ces possibilités ne sont disponibles que si les historiques correspondants ne sont pas vides.

Utiliser « défaire » et « refaire » active le statut de « triche », mais comme cela prend généralement plus de temps, ce n'est pas pris en compte dans le résultat final.

Démonstration:

La démonstration peut être utilisée pour rendre le jeu plus difficile en démarrant avec un jeu partiellement fait. Vous arrêtez la démonstration avec la barre d'espace Quand vous utilisez la démonstration pendant une partie, vous verrez votre nom associé à démo dans le tableau des meilleurs scores.

Mode plein écran:

Vous pouvez basculer du mode fenêtre au mode plein écran avec F11. (ESC ou F11 pour quitter le mode plein écran)


Problemes

Problèmes connus

Affichage incorrect:

Avec certaines cartes, certains PC, ou certains pilotes d'affichage vous pouvez avoir un affichage incorrect à certaine taille du plateau. Changez la taille du plateau pour essayer de restaurer l'affichage

Versions:

Versions de Shisen-Sho:

1.02 Corricge problème affichage menu Window 95

1.03 Nouveaux dialogue et version OS/2.

1.04 Mode Chute et barre de boutons.

1.05 Mode Attraction, Emulation souris au clavier, Affichage 3D, Bitmap de fond, Deux jeux de tuiles

1.06 Même possibilités. Code OS/2 retravaillé pour éviter des problème avec pilote GRADD .

1.07 Même possibilités. Code OS/2 retravaillé pour éviter des problème avec pilote GRADD .

1.08 Ajout de 7 jeux de tuiles dans une DLL. Ce fichier doit être dans le m^me répertoire.

1.09 Ajoute sélection de bitmap de fond

1.10 Supprime la plupart des options de triche. Ajoute re-démarre avec effacement historique.

1.11 Corrige un problème 3D introduit en 1.10. Les boutons par Klaus Staedtler-Przyborski.

1.12-Corrige un problème avec les pilotes SDD

1.13-Place le profile dans le répertoire de l'application (OS/2 version)

1.14-Ajout de jeux de tuiles externes.

1.15 Ajuste la barre de bouton (Windows XP)

1.15 Créé pur le fan club de Irina Allegrova

1.16-Version de maintenance.

1.17 Ajouter le support des langages nationaux.

1.20 Ajout du mode plein écran –réécriture du programme en UNICODE

1.30 New .Net framework version écrit en C# using Windows Presentation Fondation et Windows Form. Nécessite .Net framework version 3. (or Windows Vista)


Comment jouer

But du jeu:

C'est un jeu solitaire.

Pour jouer à Shisen-sho vous devez enlever toutes les tuiles deux par deux.

Pour pouvoir enlever une paire de tuiles, les tuiles doivent être reliées par un trait qui ne doit pas comporter plus de trois segments.

Figure 1 Relier des tuiles

Jouer à Shisen-sho:

  1. Le trait ne peut pas traverser de tuiles

  2. Vous pouvez choisir plusieurs tailles de plateau avec le Menu « option ».

  3. Souvent il est plus facile de gagner avec un plateau comportant beaucoup de tuiles qu'avec les plateaux de petites tailles.

  4. Les Meilleurs joueurs sont ceux qui gagnent dans le temps le plus court.

  5. Pour permettre une compétition équitable, la plupart des moyens de tricher ont été supprimés.


Sauvegarde du jeu

Sauver un plateau, construire un plateau

Construire le plateau:

Avant de jouer un plateau doit être construit. SHISEN-SHO (voir Historique de ce jeu et données techniques ) le fait pour vous.

Mais si le plateau ne vous convient pas vous pouvez demander un nouveau plateau. (Jeux->nouveau jeu)

Sauver et re-charger un plateau:

Vous pouvez aussi sauver un plateau sur le disque et le recharger plus tard. En sauvant un plateau vous sauvez aussi les historiques de « défaire » et « refaire » et les paramètres du jeu.

Après avoir rechargé le plateau vous pouvez soit jouer dans l'état ou repartir du début (jeux->redémarrer le jeu) avec ou sans les historiques et le compteur de temps.


TheSeaHorse

Hippocampe:

« TheSeaHorse » est le symbole de la famille de programme. Ce n'est pas le nom d'une société.

Figure 3 Un vrai hippocampe que j'ai trouvé dans la mer à 12 ans . (taille 5 cm)